# 🌱 Ceedling Pull-Request Checklist

Hello lovely developers! We hear you're interested in submitting some work to our project. Thanks! We really appreciate it! 

Below is a quick checklist of the things that need to be done before a full PR is merged to our project. Don't worry. You're not responsible for ALL of it. We'll accept your contribution however you are able to make it, with our thanks. But if you have some extra time and would like to maximize your contribution, here's a handy reference!

### Documentation

 - [ ] Has `README.md` been updated? (if it provides a huge feature or change... or maybe version bump)
 - [ ] Has `CeedlingPacket.md` been updated? (if it provides a new or changed feature)
 - [ ] Has `ReleaseNotes.md` been updated? (if it provides a new or changed feature)
 - [ ] Has `Changelog.md` been updated? (if it fixes something or provides something new)
 - [ ] Has `BreakingChanges.md` been updated? (if it changes compatibility with something that has existed before)

 ### Software

 - [ ] Does it follow our coding standards?
 - [ ] Are all existing tests passing?
 - [ ] Are there new tests added and passing?
 - [ ] Have new config options been added as defaults to the `project.yml` file?
 - [ ] Should new config options be added to example projects' `project.yml` files?
 - [ ] Does the feature follow our "Logical Defaults" philosophy where possible?
 - [ ] Has it passed a peer review?
 - [ ] Does it pass CI (continuous integration) tests?
